/*
		                  LCRZO
                             Network library
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzo.

  Lcrzo is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Lcrzo is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details (http://www.gnu.org).

------------------------------------------------------------------------
*/

#include "lcrzo_incl.h"

/*-------------------------------------------------------------*/
int lcrzo_debug_pid_get(lcrzo_uint32 * ppid)
{
#if defined LCRZODEF_SYSTEM_Unix
  if (ppid != NULL) {
    *ppid = getpid();
  }
#elif defined LCRZODEF_SYSTEM_Windows
  if (ppid != NULL) {
    *ppid = GetCurrentThreadId();
  }
#endif
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
/* We use this function because it is very simple and does not
   alloc more memory. */
int lcrzo_debug_data_print(lcrzo_constdata data,
                           lcrzo_int32 datasize)
{
  lcrzo_int32 i;

  printf("    0 :");
  for (i = 0; i < datasize; i++) {
    printf(" %02X", data[i]);
    if (!((i + 1) % 20) && i)
      printf("\n  %03d :", (int)i + 1);
  }
  puts("");
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_GLOBALVARS_NEEDED==1
 #include "sysdep/debug_globalvars.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_STR_NEEDED==1
 #include "sysdep/debug_str.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_EXEC_NEEDED==1
 #include "sysdep/debug_exec.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_BACKTRACE_NEEDED==1
 #include "sysdep/debug_backtrace.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_CS_NEEDED==1
 #include "sysdep/debug_cs.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_ERROR_OK==1
 #include "sysdep/debug_err_ok_check.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_MEMPROTECT_NEEDED==1
 #include "sysdep/debug_memprotect.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_MEM_LEAK!=0
 #include "sysdep/debug_memleak.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_MEM_CORRUPT!=0
 #include "sysdep/debug_memcorrupt.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_RES_FDOPEN==1
 #include "sysdep/debug_resfdopen.c"
#endif

/*-------------------------------------------------------------*/
#if LCRZO_DEBUG_PROCESSOTHEREXIT_WARN==1
 #include "sysdep/debug_processotherexit.c"
#endif
