/*
		                  LCRZO
                             Network library
             Copyright(c) 1999,2000,2001,2002 Laurent Constantin
                                  -----

  Main server    : http://www.laurentconstantin.com/
  Backup servers : http://go.to/laurentconstantin/
                   http://laurentconstantin.est-la.com/
                   http://laurentconstantin.free.fr/
                   http://membres.lycos.fr/lauconstantin/
  [my current email address is on the web servers]

                                  -----
  This file is part of Lcrzo.

  Lcrzo is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Lcrzo is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details (http://www.gnu.org).

------------------------------------------------------------------------
*/

/* -- Note about comments and variable names --
   In versions 1.00 up to 2.08, lcrzo was only written in French (my
   mother tongue). Since version 3.00, lcrzo is written in English, but
   most of comments and variable names are still in French.
   In future versions, I'll try to translate everything into English,
   but as you may guess, that's a quite big work...
   So, for the moment, here are some word translation, if you want to
   be able to understand what's going on in the functions :
     afficher - print     ;  ajouter - add         ;  copie - copy
     dernier - last       ;  donnee - data         ;  ecrire - write
     entete - header      ;  envoye - sent         ;  ferme - close
     fichier - file       ;  lire - read           ;  masque - mask 
     nboct - byte number  ;  ouvre, ouvrir - open  ;  paq, paquet - packet
     plage - range        ;  premier - first       ;  recu - received
     reseau - network     ;  retour - return       ;  taille - size
     tunnel - pipe

*/

#include "lcrzo_incl.h"


/*-------------------------------------------------------------*/
#if defined LCRZOTEST_HOOK_ERRORUNKNOWN
  /* useful for my private tests only */
int lcrzotest_hook_errorunknown = LCRZO_FALSE;
#endif

/*-------------------------------------------------------------*/
int lcrzo_priv_err_fprint(LCRZOFILE * pf,
                          int err,
                          int language,
                          lcrzo_bool useglobal);
int lcrzo_priv_err_fprint(LCRZOFILE * pf,
                          int err,
                          int language,
                          lcrzo_bool useglobal)
{
  switch (err) {
      /*retours normaux */
    case LCRZO_ERR_OK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OK_entxt);
      break;
    case LCRZO_ERR_OKFINISHLOOP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKFINISHLOOP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKFINISHLOOP_entxt);
      break;
    case LCRZO_ERR_OKDATAEND:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKDATAEND_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKDATAEND_entxt);
      break;
    case LCRZO_ERR_OKTEMPDATAEND:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKTEMPDATAEND_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKTEMPDATAEND_entxt);
      break;
    case LCRZO_ERR_OKSEARCHNOTFOUND:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKSEARCHNOTFOUND_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKSEARCHNOTFOUND_entxt);
      break;
    case LCRZO_ERR_OKNOTDECODED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKNOTDECODED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKNOTDECODED_entxt);
      break;
    case LCRZO_ERR_OKUNRESOLVED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKUNRESOLVED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKUNRESOLVED_entxt);
      break;
    case LCRZO_ERR_OKDATATRUNCATED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKDATATRUNCATED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKDATATRUNCATED_entxt);
      break;
    case LCRZO_ERR_OKROUTELOCALDEV:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTELOCALDEV_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTELOCALDEV_entxt);
      break;
    case LCRZO_ERR_OKROUTEHOSTUNREACH:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTEHOSTUNREACH_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTEHOSTUNREACH_entxt);
      break;
    case LCRZO_ERR_OKROUTEGWUNREACH:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTEGWUNREACH_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTEGWUNREACH_entxt);
      break;
    case LCRZO_ERR_OKROUTENOTFOUND:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTENOTFOUND_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTENOTFOUND_entxt);
      break;
    case LCRZO_ERR_OKFILENOTFOUND:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKFILENOTFOUND_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKFILENOTFOUND_entxt);
      break;
    case LCRZO_ERR_OKAVAILDATAOTHTYPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKAVAILDATAOTHTYPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKAVAILDATAOTHTYPE_entxt);
      break;
    case LCRZO_ERR_OKPROCESSABRUPTTERM:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKPROCESSABRUPTTERM_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKPROCESSABRUPTTERM_entxt);
      break;
    case LCRZO_ERR_OKROUTENOTETHER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTENOTETHER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_OKROUTENOTETHER_entxt);
      break;

      /*erreurs internes */
    case LCRZO_ERR_IE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IE_entxt);
      break;
    case LCRZO_ERR_IEUNIMPLEMENTED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEUNIMPLEMENTED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEUNIMPLEMENTED_entxt);
      break;
    case LCRZO_ERR_IEINTERNALERROR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEINTERNALERROR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEINTERNALERROR_entxt);
      break;
    case LCRZO_ERR_IEBADENDIAN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEBADENDIAN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEBADENDIAN_entxt);
      break;
    case LCRZO_ERR_IEBADSIZEOF:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEBADSIZEOF_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEBADSIZEOF_entxt);
      break;
    case LCRZO_ERR_IEOKKO:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEOKKO_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEOKKO_entxt);
      break;
    case LCRZO_ERR_IEIPCBADELEMSIZE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEIPCBADELEMSIZE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_IEIPCBADELEMSIZE_entxt);
      break;

      /*erreur des fonctions systeme */
    case LCRZO_ERR_FU:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FU_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FU_entxt);
      break;
    case LCRZO_ERR_FUSOCKET:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSOCKET_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSOCKET_entxt);
      break;
    case LCRZO_ERR_FUSENDTO:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSENDTO_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSENDTO_entxt);
      break;
    case LCRZO_ERR_FUPCAPOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPOPEN_entxt);
      break;
    case LCRZO_ERR_FUCONNECT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCONNECT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCONNECT_entxt);
      break;
    case LCRZO_ERR_FUREAD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREAD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREAD_entxt);
      break;
    case LCRZO_ERR_FUWRITE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWRITE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWRITE_entxt);
      break;
    case LCRZO_ERR_FUREGCOMP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGCOMP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGCOMP_entxt);
      break;
    case LCRZO_ERR_FUCLOSE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCLOSE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCLOSE_entxt);
      break;
    case LCRZO_ERR_FULISTEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULISTEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULISTEN_entxt);
      break;
    case LCRZO_ERR_FUACCEPT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUACCEPT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUACCEPT_entxt);
      break;
    case LCRZO_ERR_FUPCAPLOOKUPDEV:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPLOOKUPDEV_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPLOOKUPDEV_entxt);
      break;
    case LCRZO_ERR_FUPCAPLOOKUPNET:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPLOOKUPNET_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPLOOKUPNET_entxt);
      break;
    case LCRZO_ERR_FUPCAPCOMPILE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPCOMPILE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPCOMPILE_entxt);
      break;
    case LCRZO_ERR_FUPCAPSETFILTER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPSETFILTER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPSETFILTER_entxt);
      break;
    case LCRZO_ERR_FUFOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFOPEN_entxt);
      break;
    case LCRZO_ERR_FUFCLOSE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCLOSE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCLOSE_entxt);
      break;
    case LCRZO_ERR_FUSYSCTL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSYSCTL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSYSCTL_entxt);
      break;
    case LCRZO_ERR_FUMALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUMALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUMALLOC_entxt);
      break;
    case LCRZO_ERR_FUTCGETATTR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTCGETATTR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTCGETATTR_entxt);
      break;
    case LCRZO_ERR_FUTCSETATTR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTCSETATTR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTCSETATTR_entxt);
      break;
    case LCRZO_ERR_FUFSEEK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFSEEK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFSEEK_entxt);
      break;
    case LCRZO_ERR_FUIOCTL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUIOCTL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUIOCTL_entxt);
      break;
    case LCRZO_ERR_FUGETHOSTNAME:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETHOSTNAME_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETHOSTNAME_entxt);
      break;
    case LCRZO_ERR_FUKILL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUKILL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUKILL_entxt);
      break;
    case LCRZO_ERR_FUWAITPID:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWAITPID_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWAITPID_entxt);
      break;
    case LCRZO_ERR_FUPIPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPIPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPIPE_entxt);
      break;
    case LCRZO_ERR_FUFORK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFORK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFORK_entxt);
      break;
    case LCRZO_ERR_FUFCNTL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCNTL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCNTL_entxt);
      break;
    case LCRZO_ERR_FUPUTMSG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPUTMSG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPUTMSG_entxt);
      break;
    case LCRZO_ERR_FUGETMSG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETMSG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETMSG_entxt);
      break;
    case LCRZO_ERR_FULIBNETOPENLINKINT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETOPENLINKINT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETOPENLINKINT_entxt);
      break;
    case LCRZO_ERR_FULIBNETGETHWADDR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETGETHWADDR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETGETHWADDR_entxt);
      break;
    case LCRZO_ERR_FULIBNETCLOSELINKINT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETCLOSELINKINT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETCLOSELINKINT_entxt);
      break;
    case LCRZO_ERR_FULIBNETOPENRAWSOCK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETOPENRAWSOCK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETOPENRAWSOCK_entxt);
      break;
    case LCRZO_ERR_FULIBNETWRITEIP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETWRITEIP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETWRITEIP_entxt);
      break;
    case LCRZO_ERR_FULIBNETCLOSERAWSOCK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETCLOSERAWSOCK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETCLOSERAWSOCK_entxt);
      break;
    case LCRZO_ERR_FULIBNETWRITELL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETWRITELL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULIBNETWRITELL_entxt);
      break;
    case LCRZO_ERR_FUSETSOCKOPT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETSOCKOPT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETSOCKOPT_entxt);
      break;
    case LCRZO_ERR_FUBIND:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUBIND_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUBIND_entxt);
      break;
    case LCRZO_ERR_FUGETSOCKNAME:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETSOCKNAME_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETSOCKNAME_entxt);
      break;
    case LCRZO_ERR_FUGETPEERNAME:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETPEERNAME_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETPEERNAME_entxt);
      break;
    case LCRZO_ERR_FURECVFROM:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURECVFROM_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURECVFROM_entxt);
      break;
    case LCRZO_ERR_FUGETTIMEOFDAY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETTIMEOFDAY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETTIMEOFDAY_entxt);
      break;
    case LCRZO_ERR_FUOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUOPEN_entxt);
      break;
    case LCRZO_ERR_FULSTAT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULSTAT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULSTAT_entxt);
      break;
    case LCRZO_ERR_FUFSTAT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFSTAT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFSTAT_entxt);
      break;
    case LCRZO_ERR_FUSTAT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSTAT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSTAT_entxt);
      break;
    case LCRZO_ERR_FUFTRUNCATE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFTRUNCATE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFTRUNCATE_entxt);
      break;
    case LCRZO_ERR_FUSETEUID:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETEUID_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETEUID_entxt);
      break;
    case LCRZO_ERR_FUSETEGID:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETEGID_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETEGID_entxt);
      break;
    case LCRZO_ERR_FUFDOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFDOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFDOPEN_entxt);
      break;
    case LCRZO_ERR_FUREALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREALLOC_entxt);
      break;
    case LCRZO_ERR_FUPOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPOPEN_entxt);
      break;
    case LCRZO_ERR_FUPCLOSE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCLOSE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCLOSE_entxt);
      break;
    case LCRZO_ERR_FUUNLINK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUUNLINK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUUNLINK_entxt);
      break;
    case LCRZO_ERR_FUFFLUSH:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFFLUSH_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFFLUSH_entxt);
      break;
    case LCRZO_ERR_FULSEEK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULSEEK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULSEEK_entxt);
      break;
    case LCRZO_ERR_FUFSYNC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFSYNC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFSYNC_entxt);
      break;
    case LCRZO_ERR_FUFGETS:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFGETS_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFGETS_entxt);
      break;
    case LCRZO_ERR_FUFCHMOD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCHMOD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCHMOD_entxt);
      break;
    case LCRZO_ERR_FUFCHOWN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCHOWN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFCHOWN_entxt);
      break;
    case LCRZO_ERR_FUMKDIR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUMKDIR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUMKDIR_entxt);
      break;
    case LCRZO_ERR_FURENAME:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURENAME_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURENAME_entxt);
      break;
    case LCRZO_ERR_FURMDIR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURMDIR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURMDIR_entxt);
      break;
    case LCRZO_ERR_FUOPENDIR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUOPENDIR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUOPENDIR_entxt);
      break;
    case LCRZO_ERR_FUSELECT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSELECT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSELECT_entxt);
      break;
    case LCRZO_ERR_FUPCAPOPENOFFLINE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPOPENOFFLINE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPOPENOFFLINE_entxt);
      break;
    case LCRZO_ERR_FUPCAPOPENDEAD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPOPENDEAD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPOPENDEAD_entxt);
      break;
    case LCRZO_ERR_FUPCAPDUMPOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPDUMPOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPCAPDUMPOPEN_entxt);
      break;
    case LCRZO_ERR_FURAISE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURAISE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FURAISE_entxt);
      break;
    case LCRZO_ERR_FUPOLL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPOLL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPOLL_entxt);
      break;
    case LCRZO_ERR_FUCREATETHREAD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATETHREAD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATETHREAD_entxt);
      break;
    case LCRZO_ERR_FUGETEXITCODETHREAD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETEXITCODETHREAD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETEXITCODETHREAD_entxt);
      break;
    case LCRZO_ERR_FUCLOSEHANDLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCLOSEHANDLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCLOSEHANDLE_entxt);
      break;
    case LCRZO_ERR_FUWAITFORSINGLEOBJECT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWAITFORSINGLEOBJECT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWAITFORSINGLEOBJECT_entxt);
      break;
    case LCRZO_ERR_FUTERMINATETHREAD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTERMINATETHREAD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTERMINATETHREAD_entxt);
      break;
    case LCRZO_ERR_FUDUPLICATEHANDLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUDUPLICATEHANDLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUDUPLICATEHANDLE_entxt);
      break;
    case LCRZO_ERR_FUREGQUERYVALUEEX:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGQUERYVALUEEX_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGQUERYVALUEEX_entxt);
      break;
    case LCRZO_ERR_FUREGOPENKEYEX:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGOPENKEYEX_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGOPENKEYEX_entxt);
      break;
    case LCRZO_ERR_FUREGCLOSEKEY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGCLOSEKEY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGCLOSEKEY_entxt);
      break;
    case LCRZO_ERR_FULOADLIBRARY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULOADLIBRARY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULOADLIBRARY_entxt);
      break;
    case LCRZO_ERR_FUGETPROCADDRESS:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETPROCADDRESS_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETPROCADDRESS_entxt);
      break;
    case LCRZO_ERR_FUSNMPEXTENSIONINIT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSNMPEXTENSIONINIT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSNMPEXTENSIONINIT_entxt);
      break;
    case LCRZO_ERR_FUFREELIBRARY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFREELIBRARY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFREELIBRARY_entxt);
      break;
    case LCRZO_ERR_FUSNMPEXTENSIONQUERY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSNMPEXTENSIONQUERY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSNMPEXTENSIONQUERY_entxt);
      break;
    case LCRZO_ERR_FUGLOBALALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGLOBALALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGLOBALALLOC_entxt);
      break;
    case LCRZO_ERR_FUGETIPADDRTABLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIPADDRTABLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIPADDRTABLE_entxt);
      break;
    case LCRZO_ERR_FUGETIPNETTABLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIPNETTABLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIPNETTABLE_entxt);
      break;
    case LCRZO_ERR_FUGETIPFORWARDTABLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIPFORWARDTABLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIPFORWARDTABLE_entxt);
      break;
    case LCRZO_ERR_FUGETNUMBEROFINTERFACES:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETNUMBEROFINTERFACES_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETNUMBEROFINTERFACES_entxt);
      break;
    case LCRZO_ERR_FUWSASTARTUP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWSASTARTUP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWSASTARTUP_entxt);
      break;
    case LCRZO_ERR_FUWSASTARTUPVER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWSASTARTUPVER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWSASTARTUPVER_entxt);
      break;
    case LCRZO_ERR_FUWSACLEANUP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWSACLEANUP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWSACLEANUP_entxt);
      break;
    case LCRZO_ERR_FUCHSIZE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCHSIZE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCHSIZE_entxt);
      break;
    case LCRZO_ERR_FUFINDFIRST:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFINDFIRST_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFINDFIRST_entxt);
      break;
    case LCRZO_ERR_FUFINDCLOSE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFINDCLOSE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUFINDCLOSE_entxt);
      break;
    case LCRZO_ERR_FUGETSTDHANDLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETSTDHANDLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETSTDHANDLE_entxt);
      break;
    case LCRZO_ERR_FUPEEKCONSOLEINPUT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPEEKCONSOLEINPUT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPEEKCONSOLEINPUT_entxt);
      break;
    case LCRZO_ERR_FUCREATEPIPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATEPIPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATEPIPE_entxt);
      break;
    case LCRZO_ERR_FUREADFILE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREADFILE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREADFILE_entxt);
      break;

      /*erreur de formatage */
    case LCRZO_ERR_FM:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FM_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FM_entxt);
      break;
    case LCRZO_ERR_FMETH:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMETH_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMETH_entxt);
      break;
    case LCRZO_ERR_FMIP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMIP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMIP_entxt);
      break;
    case LCRZO_ERR_FMETHRANGE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMETHRANGE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMETHRANGE_entxt);
      break;
    case LCRZO_ERR_FMIPRANGE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMIPRANGE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMIPRANGE_entxt);
      break;
    case LCRZO_ERR_FMPORTRANGE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMPORTRANGE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMPORTRANGE_entxt);
      break;
    case LCRZO_ERR_FMINTFMT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMT_entxt);
      break;
    case LCRZO_ERR_FMREGEXP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMREGEXP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMREGEXP_entxt);
      break;
    case LCRZO_ERR_FMMIXED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMMIXED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMMIXED_entxt);
      break;
    case LCRZO_ERR_FMHEXACHAR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMHEXACHAR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMHEXACHAR_entxt);
      break;
    case LCRZO_ERR_FMHEXAODD:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMHEXAODD_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMHEXAODD_entxt);
      break;
    case LCRZO_ERR_FMBASE64CHAR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMBASE64CHAR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMBASE64CHAR_entxt);
      break;
    case LCRZO_ERR_FMBASE64X4:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMBASE64X4_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMBASE64X4_entxt);
      break;
    case LCRZO_ERR_FMNOTINT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMNOTINT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMNOTINT_entxt);
      break;
    case LCRZO_ERR_FMINTFMTL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMTL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMTL_entxt);
      break;
    case LCRZO_ERR_FMINTFMTU:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMTU_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMTU_entxt);
      break;
    case LCRZO_ERR_FMINTFMTI:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMTI_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FMINTFMTI_entxt);
      break;

      /*erreurs de position */
    case LCRZO_ERR_PO:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PO_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PO_entxt);
      break;
    case LCRZO_ERR_POTOOLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POTOOLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POTOOLOW_entxt);
      break;
    case LCRZO_ERR_POTOOBIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POTOOBIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POTOOBIG_entxt);
      break;
    case LCRZO_ERR_PONOZERO:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PONOZERO_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PONOZERO_entxt);
      break;
    case LCRZO_ERR_POINFTOOLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POINFTOOLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POINFTOOLOW_entxt);
      break;
    case LCRZO_ERR_POINFTOOBIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POINFTOOBIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POINFTOOBIG_entxt);
      break;
    case LCRZO_ERR_POSUPTOOLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POSUPTOOLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POSUPTOOLOW_entxt);
      break;
    case LCRZO_ERR_POSUPTOOBIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POSUPTOOBIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POSUPTOOBIG_entxt);
      break;
    case LCRZO_ERR_POINFHIGHERSUP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POINFHIGHERSUP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_POINFHIGHERSUP_entxt);
      break;

      /*erreurs de parametres */
    case LCRZO_ERR_PA:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PA_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PA_entxt);
      break;
    case LCRZO_ERR_PATOOLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PATOOLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PATOOLOW_entxt);
      break;
    case LCRZO_ERR_PATOOBIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PATOOBIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PATOOBIG_entxt);
      break;
    case LCRZO_ERR_PAINFTOOLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAINFTOOLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAINFTOOLOW_entxt);
      break;
    case LCRZO_ERR_PAINFTOOBIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAINFTOOBIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAINFTOOBIG_entxt);
      break;
    case LCRZO_ERR_PASUPTOOLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PASUPTOOLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PASUPTOOLOW_entxt);
      break;
    case LCRZO_ERR_PASUPTOOBIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PASUPTOOBIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PASUPTOOBIG_entxt);
      break;
    case LCRZO_ERR_PAINFHIGHERSUP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAINFHIGHERSUP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAINFHIGHERSUP_entxt);
      break;
    case LCRZO_ERR_PAOVERFLOW:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAOVERFLOW_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAOVERFLOW_entxt);
      break;
    case LCRZO_ERR_PADEFAULTNOTINRANGE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PADEFAULTNOTINRANGE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PADEFAULTNOTINRANGE_entxt);
      break;
    case LCRZO_ERR_PANULLPTR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PANULLPTR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PANULLPTR_entxt);
      break;
    case LCRZO_ERR_PABOOLNOT01:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PABOOLNOT01_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PABOOLNOT01_entxt);
      break;
    case LCRZO_ERR_PADATACURSUPMAX:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PADATACURSUPMAX_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PADATACURSUPMAX_entxt);
      break;
    case LCRZO_ERR_PAUNKNOWNTYPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAUNKNOWNTYPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PAUNKNOWNTYPE_entxt);
      break;
    case LCRZO_ERR_PANULLPTRSIZE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PANULLPTRSIZE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_PANULLPTRSIZE_entxt);
      break;

      /*erreurs de parametres specifiques a lcrzo */
    case LCRZO_ERR_SP:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SP_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SP_entxt);
      break;
    case LCRZO_ERR_SPOPTNOTX4:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPOPTNOTX4_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPOPTNOTX4_entxt);
      break;
    case LCRZO_ERR_SPOPTMAX10:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPOPTMAX10_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPOPTMAX10_entxt);
      break;
    case LCRZO_ERR_SPTOOBIGFORHDRL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTOOBIGFORHDRL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTOOBIGFORHDRL_entxt);
      break;
    case LCRZO_ERR_SPUNKNOWNDEVICE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPUNKNOWNDEVICE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPUNKNOWNDEVICE_entxt);
      break;
    case LCRZO_ERR_SPPATHROOTDOTDOT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHROOTDOTDOT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHROOTDOTDOT_entxt);
      break;
    case LCRZO_ERR_SPRECORDPRINTTYPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPRECORDPRINTTYPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPRECORDPRINTTYPE_entxt);
      break;
    case LCRZO_ERR_SPTIMESECOVER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMESECOVER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMESECOVER_entxt);
      break;
    case LCRZO_ERR_SPTIMEMSECOVER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMEMSECOVER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMEMSECOVER_entxt);
      break;
    case LCRZO_ERR_SPTIMEUSECOVER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMEUSECOVER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMEUSECOVER_entxt);
      break;
    case LCRZO_ERR_SPTIMETIMEOVER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMETIMEOVER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMETIMEOVER_entxt);
      break;
    case LCRZO_ERR_SPTIMEDIFFNEG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMEDIFFNEG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPTIMEDIFFNEG_entxt);
      break;
    case LCRZO_ERR_SPREGBADTYPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPREGBADTYPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPREGBADTYPE_entxt);
      break;
    case LCRZO_ERR_SPSNMPDLLBADTYPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPSNMPDLLBADTYPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPSNMPDLLBADTYPE_entxt);
      break;
    case LCRZO_ERR_SPLISTFULL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPLISTFULL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPLISTFULL_entxt);
      break;
    case LCRZO_ERR_SPFILESECURITY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPFILESECURITY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPFILESECURITY_entxt);
      break;
    case LCRZO_ERR_SPSOCKTCPNOSA:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPSOCKTCPNOSA_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPSOCKTCPNOSA_entxt);
      break;
    case LCRZO_ERR_SPSOCKTCPRST:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPSOCKTCPRST_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPSOCKTCPRST_entxt);
      break;
    case LCRZO_ERR_SPFILE2G:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPFILE2G_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPFILE2G_entxt);
      break;
    case LCRZO_ERR_SPDEVNOTETHER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPDEVNOTETHER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPDEVNOTETHER_entxt);
      break;
    case LCRZO_ERR_SPDEVNOETHERSPOOF:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPDEVNOETHERSPOOF_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPDEVNOETHERSPOOF_entxt);
      break;
    case LCRZO_ERR_SPUNIXSIGHANDLERBADSIG:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPUNIXSIGHANDLERBADSIG_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPUNIXSIGHANDLERBADSIG_entxt);
      break;
    case LCRZO_ERR_SPPATHNOTCLEANED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHNOTCLEANED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHNOTCLEANED_entxt);
      break;
    case LCRZO_ERR_SPPATHRELATIVE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHRELATIVE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHRELATIVE_entxt);
      break;
    case LCRZO_ERR_SPPATHCANTINIT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHCANTINIT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_SPPATHCANTINIT_entxt);
      break;

      /*erreurs d'emploi de la bibliotheque */
    case LCRZO_ERR_LO:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LO_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LO_entxt);
      break;
    case LCRZO_ERR_LOUDPSERMULTINOWRITE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOUDPSERMULTINOWRITE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOUDPSERMULTINOWRITE_entxt);
      break;
    case LCRZO_ERR_LOUDPSERREADBEFWRITE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOUDPSERREADBEFWRITE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOUDPSERREADBEFWRITE_entxt);
      break;
    case LCRZO_ERR_LONOTOPEN:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LONOTOPEN_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LONOTOPEN_entxt);
      break;
    case LCRZO_ERR_LONOTOPENFORREADING:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LONOTOPENFORREADING_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LONOTOPENFORREADING_entxt);
      break;
    case LCRZO_ERR_LONOTOPENFORWRITING:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LONOTOPENFORWRITING_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LONOTOPENFORWRITING_entxt);
      break;
    case LCRZO_ERR_LOALREADYCLOSED:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOALREADYCLOSED_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOALREADYCLOSED_entxt);
      break;
    case LCRZO_ERR_LOWAITLISTEMPTY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOWAITLISTEMPTY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOWAITLISTEMPTY_entxt);
      break;
    case LCRZO_ERR_LOUNKNOWNERROR:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOUNKNOWNERROR_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOUNKNOWNERROR_entxt);
      break;
    case LCRZO_ERR_LOIPCSIDENOTSET:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOIPCSIDENOTSET_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOIPCSIDENOTSET_entxt);
      break;
    case LCRZO_ERR_LOFREEUNALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOFREEUNALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOFREEUNALLOC_entxt);
      break;
    case LCRZO_ERR_LOMEMCORRUPT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOMEMCORRUPT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOMEMCORRUPT_entxt);
      break;
    case LCRZO_ERR_LOMEMDBLEFREE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOMEMDBLEFREE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_LOMEMDBLEFREE_entxt);
      break;

      /* follow up of function errors */
    case LCRZO_ERR_FUWRITEFILE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWRITEFILE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUWRITEFILE_entxt);
      break;
    case LCRZO_ERR_FUPEEKNAMEDPIPE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPEEKNAMEDPIPE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPEEKNAMEDPIPE_entxt);
      break;
    case LCRZO_ERR_FUTLSALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSALLOC_entxt);
      break;
    case LCRZO_ERR_FUTLSFREE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSFREE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSFREE_entxt);
      break;
    case LCRZO_ERR_FUTLSSETVALUE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSSETVALUE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSSETVALUE_entxt);
      break;
    case LCRZO_ERR_FUTLSGETVALUE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSGETVALUE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTLSGETVALUE_entxt);
      break;
    case LCRZO_ERR_FULOCALALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULOCALALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULOCALALLOC_entxt);
      break;
    case LCRZO_ERR_FULOCALFREE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULOCALFREE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FULOCALFREE_entxt);
      break;
    case LCRZO_ERR_FUPACKETOPENADAPTER:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETOPENADAPTER_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETOPENADAPTER_entxt);
      break;
    case LCRZO_ERR_FUPACKETSETBUFF:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETSETBUFF_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETSETBUFF_entxt);
      break;
    case LCRZO_ERR_FUPACKETALLOCATEPACKET:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETALLOCATEPACKET_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETALLOCATEPACKET_entxt);
      break;
    case LCRZO_ERR_FUPACKETSENDPACKET:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETSENDPACKET_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETSENDPACKET_entxt);
      break;
    case LCRZO_ERR_FUSETTHREADPRIORITY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETTHREADPRIORITY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETTHREADPRIORITY_entxt);
      break;
    case LCRZO_ERR_FUGETTHREADPRIORITY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETTHREADPRIORITY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETTHREADPRIORITY_entxt);
      break;
    case LCRZO_ERR_FUGETPRIORITY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETPRIORITY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETPRIORITY_entxt);
      break;
    case LCRZO_ERR_FUSETPRIORITY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETPRIORITY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETPRIORITY_entxt);
      break;
    case LCRZO_ERR_FUREGQUERYINFOKEY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGQUERYINFOKEY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGQUERYINFOKEY_entxt);
      break;
    case LCRZO_ERR_FUREGENUMKEY:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGENUMKEY_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGENUMKEY_entxt);
      break;
    case LCRZO_ERR_FUREGENUMVALUE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGENUMVALUE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUREGENUMVALUE_entxt);
      break;
    case LCRZO_ERR_FUCREATEFILE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATEFILE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATEFILE_entxt);
      break;
    case LCRZO_ERR_FUDEVICEIOCONTROL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUDEVICEIOCONTROL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUDEVICEIOCONTROL_entxt);
      break;
    case LCRZO_ERR_FUPACKETREQUEST:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETREQUEST_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETREQUEST_entxt);
      break;
    case LCRZO_ERR_FUPACKETGETADAPTERNAMES:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETGETADAPTERNAMES_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUPACKETGETADAPTERNAMES_entxt);
      break;
    case LCRZO_ERR_FUGETIFTABLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIFTABLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETIFTABLE_entxt);
      break;
    case LCRZO_ERR_FUMPROTECT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUMPROTECT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUMPROTECT_entxt);
      break;
    case LCRZO_ERR_FUVIRTUALPROTECT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUVIRTUALPROTECT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUVIRTUALPROTECT_entxt);
      break;
    case LCRZO_ERR_FUVIRTUALALLOC:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUVIRTUALALLOC_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUVIRTUALALLOC_entxt);
      break;
    case LCRZO_ERR_FUVIRTUALFREE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUVIRTUALFREE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUVIRTUALFREE_entxt);
      break;
    case LCRZO_ERR_FUGLOBALFREE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGLOBALFREE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGLOBALFREE_entxt);
      break;
    case LCRZO_ERR_FUGETRLIMIT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETRLIMIT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETRLIMIT_entxt);
      break;
    case LCRZO_ERR_FUDUP2:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUDUP2_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUDUP2_entxt);
      break;
    case LCRZO_ERR_FUEXECL:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUEXECL_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUEXECL_entxt);
      break;
    case LCRZO_ERR_FUCREATEPROCESS:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATEPROCESS_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUCREATEPROCESS_entxt);
      break;
    case LCRZO_ERR_FUSETSTDHANDLE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETSTDHANDLE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETSTDHANDLE_entxt);
      break;
    case LCRZO_ERR_FUSYMLINK:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSYMLINK_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSYMLINK_entxt);
      break;
    case LCRZO_ERR_FUOPENPROCESS:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUOPENPROCESS_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUOPENPROCESS_entxt);
      break;
    case LCRZO_ERR_FUTERMINATEPROCESS:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTERMINATEPROCESS_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUTERMINATEPROCESS_entxt);
      break;
    case LCRZO_ERR_FUSYSTEM:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSYSTEM_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSYSTEM_entxt);
      break;
    case LCRZO_ERR_FUGETCONSOLEMODE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETCONSOLEMODE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUGETCONSOLEMODE_entxt);
      break;
    case LCRZO_ERR_FUSETCONSOLEMODE:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETCONSOLEMODE_frtxt);
      else
        fprintf((FILE *) pf, "%s\n", LCRZO_ERR_FUSETCONSOLEMODE_entxt);
      break;
    case LCRZO_ERR_FUGENERATECONSOLECTRLEVENT:
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf, "%s\n",
                LCRZO_ERR_FUGENERATECONSOLECTRLEVENT_frtxt);
      else
        fprintf((FILE *) pf, "%s\n",
                LCRZO_ERR_FUGENERATECONSOLECTRLEVENT_entxt);
      break;

      /*erreur inconnue */
    default:
      {
        int (*pfunc) (int ret);
        int subret;

        if (useglobal) {
          lcrzo_er(lcrzo_global_get_err_displayfunction(&pfunc));
          if (pfunc != NULL) {
            subret = (*pfunc) (err);
            if (subret != LCRZO_ERR_OK)
              pfunc = NULL;
          }
        } else {
          pfunc = NULL;
        }
        if (pfunc == NULL) {
          if (language == LCRZO_GLOBAL_LANG_FR)
            fprintf((FILE *) pf, "code d'erreur inconnu par lcrzo.\n");
          else
            fprintf((FILE *) pf, "error code unknown by lcrzo.\n");
          fflush((FILE *) pf);
#if defined LCRZOTEST_HOOK_ERRORUNKNOWN
          if (lcrzotest_hook_errorunknown) {
            return (LCRZO_ERR_IEINTERNALERROR);
          }
#endif
        }
      }
      break;
  }

  fflush((FILE *) pf);
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
#include "sysdep/priv_err_purge_int.c"

/*-------------------------------------------------------------*/
int lcrzo_priv_err_purge_text(void)
{
  lcrzo_er(lcrzo_priv_global_set_errmsglcrzo(""));
  lcrzo_er(lcrzo_priv_global_set_errmsgsys(""));
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_err_purge(void)
{
  lcrzo_er(lcrzo_priv_err_purge_int());
  lcrzo_er(lcrzo_priv_err_purge_text());
  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
#include "sysdep/err_fprint.c"

/*-------------------------------------------------------------*/
int lcrzo_priv_err_print_noglo(int err)
{
  int ret;

  ret = lcrzo_priv_err_fprint(stdout, err,
                              (LCRZODEF_LANG == 1) ? LCRZO_GLOBAL_LANG_EN :
                              LCRZO_GLOBAL_LANG_FR, LCRZO_FALSE);
  if (ret != LCRZO_ERR_OK) {
    /* display an error indicating we could not display the error message */
    if (LCRZODEF_LANG == LCRZO_GLOBAL_LANG_FR)
      printf("lcrzo_priv_err_print_noglo: voulait afficher l'erreur %d, mais a obtenu l'erreur %d\n", err, ret);
    else
      printf("lcrzo_priv_err_print_noglo: wanted to display error %d but obtained error %d\n", err, ret);
  }
  return (LCRZO_ERR_OK);
}
