/* This file is part of Lcrzo.
*/

int lcrzo_close2(void);
int lcrzo_close2(void)
{
  /* ignore double close */
  if (!lcrzo_priv_lcrzowasinitialized) {
    return (LCRZO_ERR_OK);
  }
  lcrzo_priv_lcrzowasinitialized = LCRZO_FALSE;

#if defined LCRZODEF_SYSTEM_Unix
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(lcrzo_priv_dll_close());
  lcrzo_er(lcrzo_priv_winsock_close());
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
  lcrzo_er(lcrzo_priv_globalvars_close());

#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_er(lcrzo_priv_unix_signalhandler_child_killall());
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(lcrzo_priv_criticalsection_close());
  lcrzo_er(lcrzo_priv_close_tlsalloc());
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  lcrzo_er(lcrzo_debug_memleak_report());
  lcrzo_er(lcrzo_debug_memcorrupt_check_all());
  lcrzo_er(lcrzo_debug_memcorrupt_close());
  lcrzo_er(lcrzo_debug_memleak_close());
  lcrzo_er(lcrzo_debug_resfdopen_check());
  lcrzo_er(lcrzo_debug_globalvars_close_process());
  lcrzo_er(lcrzo_debug_globalvars_close());
  lcrzo_er(lcrzo_debug_cs_close());

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_close(void)
{
  int ret;

  ret = lcrzo_close2();
  if (ret != LCRZO_ERR_OK)      /*ignore */
    lcrzo_priv_err_print_noglo(ret);

  return (ret);
}
