/* This file is part of Lcrzo.
*/

int lcrzo_compilparam_fprint(LCRZOFILE * pf)
{
  lcrzo_int16 language;

  /*parameters verification */
  if (pf == NULL)
    return (LCRZO_ERR_PANULLPTR);

  /*affichage des entetes */
  lcrzo_er(lcrzo_global_get_language(&language));
  if (language == LCRZO_GLOBAL_LANG_FR) {
    fprintf((FILE *) pf,
            "Ce programme a ete linke avec la bibliotheque reseau ");
    fprintf((FILE *) pf, "lcrzo version %s.\n", LCRZODEF_VERSION);
    fprintf((FILE *) pf, "Lcrzo est un logiciel libre, couvert par GNU ");
    fprintf((FILE *) pf, "Lesser General Public License.\n");
    fprintf((FILE *) pf, "Lcrzo peut etre obtenu a :\n");
    fprintf((FILE *) pf, "  http://www.laurentconstantin.com/     ");
    fprintf((FILE *) pf, "(serveur principal)\n");
    fprintf((FILE *) pf, "  http://go.to/laurentconstantin/       ");
    fprintf((FILE *) pf, "(serveur de secours)\n");
    fprintf((FILE *) pf, "  http://laurentconstantin.est-la.com/  ");
    fprintf((FILE *) pf, "(serveur de secours)\n");
    fprintf((FILE *) pf,
            "Lcrzo a ete compilee avec les parametres suivants :\n");
  } else {
    fprintf((FILE *) pf, "This program was linked with the network library ");
    fprintf((FILE *) pf, "lcrzo version %s.\n", LCRZODEF_VERSION);
    fprintf((FILE *) pf,
            "Lcrzo is free software, covered by the GNU Lesser General Public License.\n");
    fprintf((FILE *) pf, "Lcrzo can be obtained at :\n");
    fprintf((FILE *) pf,
            "  http://www.laurentconstantin.com/     (main server)\n");
    fprintf((FILE *) pf,
            "  http://go.to/laurentconstantin/       (backup server)\n");
    fprintf((FILE *) pf,
            "  http://laurentconstantin.est-la.com/  (backup server)\n");
    fprintf((FILE *) pf,
            "Lcrzo was compiled with the following parameters :\n");
  }

  fprintf((FILE *) pf, "  LCRZODEF_VERSION = %s\n", LCRZODEF_VERSION);
  fprintf((FILE *) pf, "  LCRZODEF_VERSION2 = %s\n", LCRZODEF_VERSION2);
  fprintf((FILE *) pf, "  LCRZODEF_VERSIONMAJOR = %d\n",
          LCRZODEF_VERSIONMAJOR);
  fprintf((FILE *) pf, "  LCRZODEF_VERSIONMINOR = %d\n",
          LCRZODEF_VERSIONMINOR);
  fprintf((FILE *) pf, "  LCRZODEF_VERSIONMICRO = %d\n",
          LCRZODEF_VERSIONMICRO);
  fprintf((FILE *) pf, "  LCRZODEF_LANG = %d\n", LCRZODEF_LANG);
  fprintf((FILE *) pf, "  LCRZODEF_SYS = %s\n", LCRZODEF_SYS);
  fprintf((FILE *) pf, "  LCRZODEF_SYSTEM = %s\n", LCRZODEF_SYSTEM);
  fprintf((FILE *) pf, "  LCRZODEF_SYSVER = %s\n", LCRZODEF_SYSVER);
  fprintf((FILE *) pf, "  LCRZODEF_SYSTEMVERS = %s\n", LCRZODEF_SYSTEMVERS);
  fprintf((FILE *) pf, "  LCRZODEF_SYSTEMARCH = %s\n", LCRZODEF_SYSTEMARCH);
  fprintf((FILE *) pf, "  LCRZODEF_ENDIANLITTLE = %d\n",
          LCRZODEF_ENDIANLITTLE);
  fprintf((FILE *) pf, "  LCRZODEF_ENDIANBIG = %d\n", LCRZODEF_ENDIANBIG);
  fprintf((FILE *) pf, "  LCRZODEF_LIBPCAPINSTALLED = %d\n",
          LCRZODEF_LIBPCAPINSTALLED);
  fprintf((FILE *) pf, "  LCRZODEF_LIBPCAPFROMREDHAT = %d\n",
          LCRZODEF_LIBPCAPFROMREDHAT);
  fprintf((FILE *) pf, "  LCRZODEF_LIBNETINSTALLED = %d\n",
          LCRZODEF_LIBNETINSTALLED);
  fprintf((FILE *) pf, "  LCRZODEF_PROGCC = %s\n", LCRZODEF_PROGCC);
  fprintf((FILE *) pf, "  LCRZODEF_PROGAR = %s\n", LCRZODEF_PROGAR);
  fprintf((FILE *) pf, "  LCRZODEF_PROGRANLIB = %s\n", LCRZODEF_PROGRANLIB);
  fprintf((FILE *) pf, "  LCRZODEF_INSTINCLUDE = %s\n", LCRZODEF_INSTINCLUDE);
  fprintf((FILE *) pf, "  LCRZODEF_INSTLIB = %s\n", LCRZODEF_INSTLIB);
  fprintf((FILE *) pf, "  LCRZODEF_INSTBIN = %s\n", LCRZODEF_INSTBIN);
  fprintf((FILE *) pf, "  LCRZODEF_INSTMAN1 = %s\n", LCRZODEF_INSTMAN1);
  fprintf((FILE *) pf, "  LCRZODEF_INSTMAN3 = %s\n", LCRZODEF_INSTMAN3);
  fprintf((FILE *) pf, "  LCRZODEF_INSTUSERGROUP = %s\n",
          LCRZODEF_INSTUSERGROUP);
  fprintf((FILE *) pf, "  LCRZODEF_HAVETYPE_SIZE_T = %d\n",
          LCRZODEF_HAVETYPE_SIZE_T);
  fprintf((FILE *) pf, "  LCRZODEF_HAVETYPE_SOCKLEN_T = %d\n",
          LCRZODEF_HAVETYPE_SOCKLEN_T);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_ETHER_NTOHOST = %d\n",
          LCRZODEF_HAVEFONC_ETHER_NTOHOST);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_ETHER_HOSTTON = %d\n",
          LCRZODEF_HAVEFONC_ETHER_HOSTTON);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_HSTRERROR = %d\n",
          LCRZODEF_HAVEFONC_HSTRERROR);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_SNPRINTF = %d\n",
          LCRZODEF_HAVEFONC_SNPRINTF);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_IOCTL_BIOCSHDRCMPLT = %d\n",
          LCRZODEF_HAVEFONC_IOCTL_BIOCSHDRCMPLT);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_PCAP_FREECODE = %d\n",
          LCRZODEF_HAVEFONC_PCAP_FREECODE);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_PCAP_OPENDEAD = %d\n",
          LCRZODEF_HAVEFONC_PCAP_OPENDEAD);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEFONC_POLL = %d\n",
          LCRZODEF_HAVEFONC_POLL);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEINCL_NETPACKET_PACKET = %d\n",
          LCRZODEF_HAVEINCL_NETPACKET_PACKET);
  fprintf((FILE *) pf, "  LCRZODEF_HAVEINCL_SYS_BUFMOD = %d\n",
          LCRZODEF_HAVEINCL_SYS_BUFMOD);

#if defined LCRZODEF_SYSTEM_Unix
#elif defined LCRZODEF_SYSTEM_Windows
  {
    int ret;
    lcrzo_uint32 systemversion, spmajor, spminor, build;

    ret =
      lcrzo_windows_getsystemversion(&systemversion, &spmajor, &spminor,
                                     &build);
    if (ret == LCRZO_ERR_OK) {
      if (language == LCRZO_GLOBAL_LANG_FR)
        fprintf((FILE *) pf,
                "\nCe programme s'execute sur une machine de type :\n");
      else
        fprintf((FILE *) pf, "\nThis program is currently run on :\n");
      switch ((int)systemversion) {
        case LCRZO_WINDOWS_SYSTEMVERSION_31:
          fprintf((FILE *) pf, "  Windows 3.1\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_95:
          fprintf((FILE *) pf, "  Windows 95\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_98:
          fprintf((FILE *) pf, "  Windows 98\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_me:
          fprintf((FILE *) pf, "  Windows Me\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_nt350:
          fprintf((FILE *) pf, "  Windows NT 3.5\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_nt351:
          fprintf((FILE *) pf, "  Windows NT 3.51\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_nt4:
          fprintf((FILE *) pf, "  Windows NT 4\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_2k:
          fprintf((FILE *) pf, "  Windows 2000\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_xp:
          fprintf((FILE *) pf, "  Windows XP\n");
          break;
        case LCRZO_WINDOWS_SYSTEMVERSION_net:
          fprintf((FILE *) pf, "  Windows .NET\n");
          break;
        default:
          fprintf((FILE *) pf, "  Windows\n");
          break;
      }
      fprintf((FILE *) pf, "  Service Pack %lu.%lu\n", spmajor, spminor);
      fprintf((FILE *) pf, "  Build %lu\n", build);
    }
  }
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  fflush((FILE *) pf);
  return (LCRZO_ERR_OK);
}
