/* This file is part of Lcrzo.
*/

int lcrzo_dir_create(lcrzo_conststring dirname)
{
  int ret;
  lcrzo_string cleandirname;

  lcrzo_er(lcrzo_path_clean(dirname, &cleandirname));
  ret = lcrzo_priv_path_create_parentdirs(cleandirname, LCRZO_TRUE);
  if (ret != LCRZO_ERR_OK) {
    lcrzo_er(lcrzo_string_free2(&cleandirname));
    return (ret);
  }
#if defined LCRZODEF_SYSTEM_Unix
  ret = mkdir(cleandirname, 0700);
#elif defined LCRZODEF_SYSTEM_Windows
  ret = _mkdir(cleandirname);
  if (ret == -1) {
    if (errno == ENOENT) {
      lcrzo_er(lcrzo_priv_err_purge_int());
      lcrzo_er(lcrzo_priv_winpath240_check(cleandirname));
    }
  }
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  if (ret == -1) {
    lcrzo_debug_err_ok_activate(LCRZO_FALSE);
    lcrzo_er(lcrzo_priv_global_set_errmsglcrzo(cleandirname));
    lcrzo_er(lcrzo_string_free2(&cleandirname));
    lcrzo_debug_err_ok_activate(LCRZO_TRUE);
    return (LCRZO_ERR_FUMKDIR);
  }
  lcrzo_er(lcrzo_string_free2(&cleandirname));

  return (LCRZO_ERR_OK);
}
