/* This file is part of Lcrzo.
*/

int lcrzo_dir_exist(lcrzo_conststring dirname,
                    lcrzo_bool * pyes)
{
  int ret;
  struct stat st;
  lcrzo_bool direxists;

  direxists = LCRZO_FALSE;

  ret = lcrzo_priv_path_stat_get(dirname, &st);
  if (ret == LCRZO_ERR_OK) {
#if defined LCRZODEF_SYSTEM_Unix
    if (S_ISDIR(st.st_mode))
#elif defined LCRZODEF_SYSTEM_Windows
    if (st.st_mode & _S_IFDIR)
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
    {
      direxists = LCRZO_TRUE;
    }
  } else if (ret == LCRZO_ERR_OKFILENOTFOUND) {
    direxists = LCRZO_FALSE;
    lcrzo_er(lcrzo_priv_err_purge_text());
  } else {
    return (ret);
  }

  if (pyes != NULL) {
    *pyes = direxists;
  }

  return (LCRZO_ERR_OK);
}
