/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
int lcrzo_file_flush(lcrzo_file * pfile)
{
  int ret;

  if (pfile == NULL)
    return (LCRZO_ERR_OK);

  if (pfile->openforwriting) {
#if defined LCRZODEF_SYSTEM_Unix
    ret = fsync(pfile->fd);
#elif defined LCRZODEF_SYSTEM_Windows
    ret = _commit(pfile->fd);
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
    if (ret < 0)
      return (LCRZO_ERR_FUFSYNC);
  }
  return (LCRZO_ERR_OK);
}
