/* This file is part of Lcrzo.
*/

int lcrzo_filename_exist(lcrzo_conststring filename,
                         lcrzo_bool * pyes)
{
  int ret;
  struct stat st;
  lcrzo_bool fileexists;

  fileexists = LCRZO_FALSE;

  ret = lcrzo_priv_path_stat_get(filename, &st);
  if (ret == LCRZO_ERR_OK) {
#if defined LCRZODEF_SYSTEM_Unix
    if (S_ISREG(st.st_mode))
#elif defined LCRZODEF_SYSTEM_Windows
    if (st.st_mode & _S_IFREG)
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
    {
      fileexists = LCRZO_TRUE;
    }
  } else if (ret == LCRZO_ERR_OKFILENOTFOUND) {
    fileexists = LCRZO_FALSE;
    lcrzo_er(lcrzo_priv_err_purge_text());
  } else {
    return (ret);
  }

  if (pyes != NULL) {
    *pyes = fileexists;
  }

  return (LCRZO_ERR_OK);
}
