/* This file is part of Lcrzo.
*/

lcrzo_bool lcrzo_priv_lcrzowasinitialized = LCRZO_FALSE;
int lcrzo_init2(void);
int lcrzo_init2(void)
{
  /* ignore double initialization */
  if (lcrzo_priv_lcrzowasinitialized) {
    return (LCRZO_ERR_OK);
  }
  lcrzo_priv_lcrzowasinitialized = LCRZO_TRUE;

#if defined LCRZODEF_SYSTEM_Unix
#elif defined LCRZODEF_SYSTEM_Windows
  lcrzo_er(lcrzo_priv_init_tlsalloc());
  lcrzo_er(lcrzo_priv_criticalsection_init());
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  lcrzo_er(lcrzo_debug_cs_init());
  lcrzo_er(lcrzo_debug_globalvars_init());
  lcrzo_er(lcrzo_debug_globalvars_init_process());
  lcrzo_er(lcrzo_debug_memleak_init());
  lcrzo_er(lcrzo_debug_memcorrupt_init());

  lcrzo_er(lcrzo_priv_globalvars_init());

#if defined LCRZODEF_SYSTEM_Unix
  lcrzo_er(lcrzo_priv_unix_signalhandler_init());
  lcrzo_er(lcrzo_priv_unix_signalhandler_firstprocess_init());
  lcrzo_er(lcrzo_priv_unix_signalhandler_child_init());
#elif defined LCRZODEF_SYSTEM_Windows
  /* init winsock 1.1 */
  lcrzo_er(lcrzo_priv_winsock_init());
  /* load dlls */
  lcrzo_er(lcrzo_priv_dll_init());
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  return (LCRZO_ERR_OK);
}

/*-------------------------------------------------------------*/
int lcrzo_init(void)
{
  int ret;

  ret = lcrzo_init2();
  if (ret != LCRZO_ERR_OK)      /*ignore */
    lcrzo_priv_err_print_noglo(ret);

  return (ret);
}
