/* This file is part of Lcrzo.
*/

int lcrzo_ipc_close_notneeded(lcrzo_ipc * pipc)
{
  int ret;

  /*parameters verification */
  if (pipc == NULL)
    return (LCRZO_ERR_PANULLPTR);

  /* close */
#if defined LCRZODEF_SYSTEM_Unix
  if (pipc->side == -1) {
    ret = close(pipc->readpipe[0]);
    if (ret == -1)
      return (LCRZO_ERR_FUCLOSE);
    ret = close(pipc->readpipe[1]);
    if (ret == -1)
      return (LCRZO_ERR_FUCLOSE);
    ret = close(pipc->writepipe[0]);
    if (ret == -1)
      return (LCRZO_ERR_FUCLOSE);
    ret = close(pipc->writepipe[1]);
    if (ret == -1)
      return (LCRZO_ERR_FUCLOSE);
  } else {
    if (pipc->openforreading) {
      ret = close(pipc->readpipe[pipc->side]);
      if (ret == -1)
        return (LCRZO_ERR_FUCLOSE);
#if defined LCRZOTEST_HOOK_IPCSIDE
      if (lcrzotest_hook_ipcside == LCRZO_TRUE) {
        ret = close(pipc->readpipe[(pipc->side == 1) ? 0 : 1]);
        if (ret == -1)
          return (LCRZO_ERR_FUCLOSE);
      }
#endif
      pipc->openforreading = LCRZO_FALSE;
    }
    if (pipc->openforwriting) {
      ret = close(pipc->writepipe[pipc->side]);
      if (ret == -1)
        return (LCRZO_ERR_FUCLOSE);
#if defined LCRZOTEST_HOOK_IPCSIDE
      if (lcrzotest_hook_ipcside == LCRZO_TRUE) {
        ret = close(pipc->writepipe[(pipc->side == 1) ? 0 : 1]);
        if (ret == -1)
          return (LCRZO_ERR_FUCLOSE);
      }
#endif
      pipc->openforwriting = LCRZO_FALSE;
    }
  }
#elif defined LCRZODEF_SYSTEM_Windows
  ret = LCRZO_ERR_OK;           /* for the compiler warning */
  pipc->openforreading = LCRZO_FALSE;
  pipc->openforwriting = LCRZO_FALSE;
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  pipc->dataend = LCRZO_TRUE;
  return (LCRZO_ERR_OK);
}
