/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
int lcrzo_kbd_purge(lcrzo_kbd * pkbd)
{
  if (pkbd->type == LCRZO_PRIV_HANDLE_TYPE_CONSOLE) {
#if defined LCRZODEF_SYSTEM_Unix
    int old_fc, new_fc, c;

    /* ensure the getc will not block */
    if ((old_fc = fcntl(pkbd->fd, F_GETFL, 0)) == -1) {
      return (LCRZO_ERR_FUFCNTL);
    }
    new_fc = old_fc | O_NONBLOCK;
    if (fcntl(pkbd->fd, F_SETFL, new_fc) == -1) {
      return (LCRZO_ERR_FUFCNTL);
    }
    do {
      c = getchar();
    } while (c != EOF);
    /* reset */
    if (fcntl(pkbd->fd, F_SETFL, old_fc) == -1) {
      return (LCRZO_ERR_FUFCNTL);
    }
    errno = 0;
#elif defined LCRZODEF_SYSTEM_Windows
    while (_kbhit())
      _getch();
    lcrzo_er(lcrzo_priv_err_purge_int());
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
  }
  return (LCRZO_ERR_OK);
}
