/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
int lcrzo_priv_etha_init_ipa_iphlpapi(lcrzo_constipa ipa,
                                      lcrzo_etha etha)
/* cette fonction interroge Winsock */
#if defined LCRZODEF_SYSTEM_Unix
{
  return (LCRZO_ERR_OKUNRESOLVED);
  {
    int i;

    /* just for the compiler warning */
    if (ipa == NULL && etha == NULL)
      i = 0;
  }
}
#elif defined LCRZODEF_SYSTEM_Windows
{
  lcrzo_ipl ipl;
  lcrzo_uint32 bufsize;
  ULONG ethalocal[LCRZO_ETHA_MAXBYTES];
  lcrzo_etha ethalocal2;
  lcrzo_priv_globalvars *ptrglo;
  int ret;

  if (!lcrzo_global_dll_iphlpapi.isloaded)
    return (LCRZO_ERR_OKUNRESOLVED);

  lcrzo_er(lcrzo_priv_globalvars_ptr_get(&ptrglo));
  switch ((int)ptrglo->windows_systemversion) {
    case LCRZO_WINDOWS_SYSTEMVERSION_31:
    case LCRZO_WINDOWS_SYSTEMVERSION_95:
    case LCRZO_WINDOWS_SYSTEMVERSION_98:
    case LCRZO_WINDOWS_SYSTEMVERSION_me:
    case LCRZO_WINDOWS_SYSTEMVERSION_nt350:
    case LCRZO_WINDOWS_SYSTEMVERSION_nt351:
    case LCRZO_WINDOWS_SYSTEMVERSION_nt4:
      /* SendARP is unsupported */
      return (LCRZO_ERR_OKUNRESOLVED);
      break;
  }

  /* init wanted address */
  lcrzo_er(lcrzo_ipl_init_ipa(ipa, &ipl));

  /* send the request */
  bufsize = LCRZO_ETHA_MAXBYTES;
  ret =
    lcrzo_global_dll_iphlpapi.SendARP(lcrzo_htonl(ipl), 0, ethalocal,
                                      &bufsize);
  if (ret != NO_ERROR) {
    return (LCRZO_ERR_OKUNRESOLVED);
  }
  lcrzo_er(lcrzo_priv_err_purge_int());

  /* check the size */
  if (bufsize != LCRZO_ETHA_MAXBYTES) {
    return (LCRZO_ERR_OKUNRESOLVED);
  }

  /* set output */
  memcpy(ethalocal2, ethalocal, LCRZO_ETHA_MAXBYTES);
  ret = lcrzo_priv_conf_arp_add_system("", ethalocal2, ipl, LCRZO_FALSE);
  if (ret != LCRZO_ERR_OK) {
    return (ret);
  }
  if (etha != NULL) {
    memcpy(etha, ethalocal2, LCRZO_ETHA_MAXBYTES);
  }

  return (LCRZO_ERR_OK);
}
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
