/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
int lcrzo_priv_kbd_key_press(lcrzo_kbd * pkbd)
#if defined LCRZODEF_SYSTEM_Unix
{
  return (lcrzo_priv_kbd_key_noecho(pkbd, NULL));
}
#elif defined LCRZODEF_SYSTEM_Windows
{
  lcrzo_uint8 carac;
  BOOL err;

  lcrzo_er(lcrzo_kbd_purge(pkbd));

  /* cases which cannot be treated here */
  if (pkbd->type != LCRZO_PRIV_HANDLE_TYPE_CONSOLE) {
    return (lcrzo_priv_kbd_key_noecho2(pkbd, NULL));
  }

  carac = (lcrzo_uint8) _getch();
  if (carac == 0x00) {
    /* on Function-i, get the second part */
    _getch();
  } else if (carac == 0xE0) {
    /* arrow key, but get the second part */
    _getch();
  } else if (carac == 0x03) {
    /* on control-c, generate the event (then the program should exit) */
    err = GenerateConsoleCtrlEvent(CTRL_C_EVENT, 0);
    if (!err) {
      return (LCRZO_ERR_FUGENERATECONSOLECTRLEVENT);
    }
  }
  lcrzo_er(lcrzo_priv_err_purge_int());

  return (LCRZO_ERR_OK);
}
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
