/* This file is part of Lcrzo.
*/

/*-------------------------------------------------------------*/
int lcrzo_priv_kbd_set_echo(lcrzo_kbd * pkbd,
                            lcrzo_bool echokeypresses)
#if defined LCRZODEF_SYSTEM_Unix
{
  struct termios thetermios;

  /* change mode */
  if (tcgetattr(pkbd->fd, &thetermios))
    return (LCRZO_ERR_FUTCGETATTR);

  if (echokeypresses) {
    if (thetermios.c_lflag & ECHO) {
      /* already ok */
      pkbd->echokeypresses = echokeypresses;
      return (LCRZO_ERR_OK);
    }
    thetermios.c_lflag |= ECHO;
  } else {
    if (!(thetermios.c_lflag & ECHO)) {
      /* already ok */
      pkbd->echokeypresses = echokeypresses;
      return (LCRZO_ERR_OK);
    }
    thetermios.c_lflag &= ~ECHO;
  }

  if (tcsetattr(pkbd->fd, TCSANOW, &thetermios))
    return (LCRZO_ERR_FUTCSETATTR);

  pkbd->echokeypresses = echokeypresses;

  return (LCRZO_ERR_OK);
}
#elif defined LCRZODEF_SYSTEM_Windows
{
  /* we cannot do something else. We'll then use getch/getche */
  pkbd->echokeypresses = echokeypresses;
  return (LCRZO_ERR_OK);
}
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
