/* This file is part of Lcrzo.
*/

int lcrzo_priv_spoof_supports_eth2(lcrzo_int16 hwtype,
                                   lcrzo_bool * pyes);
int lcrzo_priv_spoof_supports_eth2(lcrzo_int16 hwtype,
                                   lcrzo_bool * pyes)
#ifdef LCRZODEF_SYSTEM_Linux
/*-------------------------------------------------------------*/
{
  lcrzo_bool b;

  switch (hwtype) {
    case LCRZO_DEVICE_HWTYPE_ETHER:
    case LCRZO_DEVICE_HWTYPE_LOOPBACK:
      b = LCRZO_TRUE;
      break;
    case LCRZO_DEVICE_HWTYPE_PPP:
      b = LCRZO_FALSE;
      break;
    default:
      /* to support new devices, say it's OK */
      b = LCRZO_TRUE;
  }

  if (pyes != NULL)
    *pyes = b;
  return (LCRZO_ERR_OK);
}
#elif defined LCRZODEF_SYSTEM_FreeBSD || defined LCRZODEF_SYSTEM_OpenBSD | defined LCRZODEF_SYSTEM_MacOS
/*-------------------------------------------------------------*/
{
  lcrzo_bool b;

  switch (hwtype) {
    case LCRZO_DEVICE_HWTYPE_ETHER:
      b = LCRZO_TRUE;
      break;
    case LCRZO_DEVICE_HWTYPE_LOOPBACK:
    case LCRZO_DEVICE_HWTYPE_PPP:
      b = LCRZO_FALSE;
      break;
    default:
      /* to support new devices, say it's OK */
      b = LCRZO_TRUE;
  }

  if (pyes != NULL)
    *pyes = b;
  return (LCRZO_ERR_OK);
}
#elif defined LCRZODEF_SYSTEM_Solaris
/*-------------------------------------------------------------*/
{
  lcrzo_bool b;

  switch (hwtype) {
    case LCRZO_DEVICE_HWTYPE_ETHER:
      b = LCRZO_TRUE;
      break;
    case LCRZO_DEVICE_HWTYPE_LOOPBACK:
    case LCRZO_DEVICE_HWTYPE_PPP:
      b = LCRZO_FALSE;
      break;
    default:
      /* to support new devices, say it's OK */
      b = LCRZO_TRUE;
  }

  if (pyes != NULL)
    *pyes = b;
  return (LCRZO_ERR_OK);
}
#elif defined LCRZODEF_SYSTEM_Unsupported
/*-------------------------------------------------------------*/
{
  if (pyes != NULL)
    *pyes = LCRZO_TRUE;
  return (LCRZO_ERR_OK);
  hwtype = hwtype;
}
#elif defined LCRZODEF_SYSTEM_Windows
/*-------------------------------------------------------------*/
{
  lcrzo_bool b;

  switch (hwtype) {
    case LCRZO_DEVICE_HWTYPE_ETHER:
      b = LCRZO_TRUE;
      break;
    case LCRZO_DEVICE_HWTYPE_LOOPBACK:
    case LCRZO_DEVICE_HWTYPE_PPP:
      b = LCRZO_FALSE;
      break;
    default:
      /* to support new devices, say it's OK */
      b = LCRZO_TRUE;
  }

  if (pyes != NULL)
    *pyes = b;
  return (LCRZO_ERR_OK);
}
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
/*-------------------------------------------------------------*/
     int lcrzo_priv_spoof_supports_eth(lcrzo_constdevice device,
                                       lcrzo_bool * pyes)
{
  lcrzo_device dev, devicenoalias, devnoalias;
  lcrzo_int32 i, count;
  lcrzo_int16 hwtype;
  lcrzo_bool deviceequal;

  lcrzo_er(lcrzo_device_init_noalias(device, devicenoalias));
  lcrzo_er(lcrzo_conf_devices_count(&count));

  for (i = 1; i <= count; i++) {
    lcrzo_er(lcrzo_conf_devices_value_pos(i, dev, &hwtype,
                                          NULL, NULL, NULL, NULL,
                                          NULL, NULL, NULL, NULL));
    lcrzo_er(lcrzo_device_init_noalias(dev, devnoalias));

    lcrzo_er(lcrzo_device_equal2(devicenoalias, devnoalias, &deviceequal));
    if (deviceequal) {
      lcrzo_er(lcrzo_priv_spoof_supports_eth2(hwtype, pyes));
      /* stop here */
      return (LCRZO_ERR_OK);
    }
  }

  /* didn't found the device. Suppose it's OK (to support new devices). */
  if (pyes != NULL)
    *pyes = LCRZO_TRUE;
  return (LCRZO_ERR_OK);
}
