/* This file is part of Lcrzo.
*/

int lcrzo_priv_wait_winhandle_read(lcrzo_winhandle * pwinhandle)
#if defined LCRZODEF_SYSTEM_Unix
{
  return (LCRZO_ERR_IEUNIMPLEMENTED);
  pwinhandle = pwinhandle;
}
#elif defined LCRZODEF_SYSTEM_Windows
{
  lcrzo_int32 readsize;
  lcrzo_data ptr;
  BOOL err;

  switch (pwinhandle->type) {
    case LCRZO_PRIV_HANDLE_TYPE_FILE:
    case LCRZO_PRIV_HANDLE_TYPE_UNKNOWN:
    case LCRZO_PRIV_HANDLE_TYPE_CONSOLE:
    case LCRZO_PRIV_HANDLE_TYPE_PIPE:
      break;
    default:
      return (lcrzo_ieuv
              ("lcrzo_priv_wait_winhandle_read", "pwinhandle->type"));
  }

  lcrzo_er(lcrzo_data_alloc(LCRZO_PRIV_READMAXMSGSIZE, &ptr));

  err = ReadFile(pwinhandle->thehandle, ptr, LCRZO_PRIV_READMAXMSGSIZE,
                 (PULONG) & readsize, NULL);
  if (!err) {
    lcrzo_er(lcrzo_data_free2(&ptr));
    return (LCRZO_ERR_OKDATAEND);
  }
  if (readsize == 0) {
    lcrzo_er(lcrzo_data_free2(&ptr));
    return (LCRZO_ERR_OKDATAEND);
  }

  /* put read data in stored data */
  lcrzo_er(lcrzo_priv_storeddata_append(ptr, readsize,
                                        &(pwinhandle->storeddata),
                                        &(pwinhandle->storeddatasize)));
  lcrzo_er(lcrzo_data_free2(&ptr));

  return (LCRZO_ERR_OK);
}
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
