/* This file is part of Lcrzo.
*/

int lcrzo_spoof_set_useethforip(lcrzo_spoof * pspoof,
                                lcrzo_bool useethforip)
{
  if (pspoof == NULL)
    return (LCRZO_ERR_PANULLPTR);

#if defined LCRZODEF_SYSTEM_Unix
  pspoof->para_useethforip = useethforip;
#elif defined LCRZODEF_SYSTEM_Windows
  {
    lcrzo_bool supportsip;

    lcrzo_er(lcrzo_priv_spoof_supports_ip(&supportsip));
    if (supportsip)
      pspoof->para_useethforip = useethforip;
    else
      pspoof->para_useethforip = LCRZO_TRUE;
  }
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif

  return (LCRZO_ERR_OK);
}
