/* This file is part of Lcrzo.
*/

int lcrzo_time_pause_msec(lcrzo_uint32 msec)
#if defined LCRZODEF_SYSTEM_Unix
{
  lcrzo_uint32 time_sleep_threshold3;

  lcrzo_er(lcrzo_global_get_time_sleep_3threshold(&time_sleep_threshold3));
  if (msec < time_sleep_threshold3 / 1000) {
    /*utilise usleep */
    usleep(msec * 1000);
  } else {
    /*utilise sleep */
    sleep(msec / 1000);
  }

  errno = 0;                    /*because Solaris sets errno to 4 */
  return (LCRZO_ERR_OK);
}
#elif defined LCRZODEF_SYSTEM_Windows
{
  Sleep(msec);
  return (LCRZO_ERR_OK);
}
#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
