/* This file is part of Lcrzo.
*/

int lcrzo_winhandle_init_handle(LCRZOHANDLE thehandle,
                                lcrzo_winhandle * pwinhandle)
#if defined LCRZODEF_SYSTEM_Unix
{
  return (LCRZO_ERR_IEUNIMPLEMENTED);
  thehandle = thehandle;
  pwinhandle = pwinhandle;
}
#elif defined LCRZODEF_SYSTEM_Windows
{
  lcrzo_int16 type;
  DWORD ftype;

  /* first, try to determine the type of the handle */
  type = LCRZO_PRIV_HANDLE_TYPE_UNKNOWN;
  ftype = GetFileType(thehandle);
  if (ftype == FILE_TYPE_CHAR) {
    type = LCRZO_PRIV_HANDLE_TYPE_CONSOLE;
  } else if (ftype == FILE_TYPE_DISK) {
    type = LCRZO_PRIV_HANDLE_TYPE_FILE;
  } else if (ftype == FILE_TYPE_PIPE) {
    type = LCRZO_PRIV_HANDLE_TYPE_PIPE;
  }
  lcrzo_er(lcrzo_priv_err_purge_int());

#if 0
  /* old method */
  BOOL err;
  DWORD consolemode;
  BY_HANDLE_FILE_INFORMATION bhfi;
  DWORD readbytes, bytesavail;

  err = GetConsoleMode(thehandle, &consolemode);
  if (err) {
    type = LCRZO_PRIV_HANDLE_TYPE_CONSOLE;
  }
  if (type == LCRZO_PRIV_HANDLE_TYPE_UNKNOWN) {
    err = GetFileInformationByHandle(thehandle, &bhfi);
    if (err) {
      type = LCRZO_PRIV_HANDLE_TYPE_FILE;
    }
  }
  if (type == LCRZO_PRIV_HANDLE_TYPE_UNKNOWN) {
    err =
      PeekNamedPipe(thehandle, NULL, 0xFFFF, &readbytes, &bytesavail, NULL);
    if (err) {
      type = LCRZO_PRIV_HANDLE_TYPE_PIPE;
    }
  }
#endif

  if (pwinhandle != NULL) {
    pwinhandle->thehandle = thehandle;
    pwinhandle->openforreading = LCRZO_TRUE;
    pwinhandle->openforwriting = LCRZO_TRUE;
    pwinhandle->dataend = LCRZO_FALSE;
    pwinhandle->storeddata = NULL;
    pwinhandle->storeddatasize = 0;
    pwinhandle->type = type;
  }

  return (LCRZO_ERR_OK);
}

#else
#error "Unknown value for LCRZODEF_SYSTEM"
#endif
